#if READONLY_TEST
// idea from 2004 Wout de Zeeuw

using System;
s
namespace CaveArt.UIcomp
{
	/// <summary>
	/// Use ReadOnlyAttribute on a property to change its ReadOnly Attribute Dynamically.	
	/// </summary>
	/// <remarks>
	/// Must use with <see cref="SPOSTypeConverter"/> to have effect.
	/// </remarks>
	[AttributeUsage(AttributeTargets.Property)]
	public class ReadOnlyAttribute : Attribute
	{
		private bool read_only;
	    
		public ReadOnlyAttribute(bool _readonly)
		{
			this.read_only = _readonly;
		}
		
		public bool ReadOnly 
		{
			get 
			{
				return read_only;
			}
			set 
			{
				read_only = value;
			}
		}
	}
}
#endif